## ros-indigo-schunk-canopen-driver 1.0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

SET(ICMAKER_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/icmaker")
INCLUDE(${ICMAKER_DIRECTORY}/CMakeLists.txt)

project(schunk_canopen_driver)

FIND_PACKAGE( icl_core REQUIRED)
FIND_PACKAGE( icl_hardware_can REQUIRED)
FIND_PACKAGE( icl_comm OPTIONAL_COMPONENTS icl_comm_websocket)
ADD_SUBDIRECTORY (src/icl_hardware_canopen)
FIND_PACKAGE( icl_hardware_canopen REQUIRED)


## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  actionlib
  control_msgs
  controller_manager
  hardware_interface
  joint_limits_interface
  message_generation
  roscpp
  sensor_msgs
  std_msgs
  std_srvs
  urdf
)



# generate_dynamic_reconfigure_options(
#   cfg/schunk_canopen_driver_config.cfg
# )


add_definitions( ${icl_hardware_can_DEFINITIONS} )
add_definitions( ${icl_hardware_canopen_DEFINITIONS} )
add_definitions( ${icl_core_DEFINITIONS} )
add_definitions( ${icl_comm_DEFINITIONS} )

if(icl_comm_icl_comm_websocket_FOUND)
  message(STATUS "Building schunk_canopen_driver with icl_comm_websocket support.")
else()
  message(STATUS "Building schunk_canopen_driver without icl_comm_websocket support.")
endif()

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependencies might have been
##     pulled in transitively but can be declared for certainty nonetheless:
##     * add a build_depend tag for "message_generation"
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
#   Message1.msg
#   Message2.msg
# )

## Generate services in the 'srv' folder
add_service_files(
   FILES
   HomeAll.srv
   HomeWithIDs.srv
   HomeWithJointNames.srv
)

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
   DEPENDENCIES
   control_msgs
   sensor_msgs
   std_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES
  CATKIN_DEPENDS
    actionlib
    controller_manager
    hardware_interface
    joint_limits_interface
    message_runtime
    roscpp
    std_srvs
  DEPENDS
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
#include_directories(include)
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${icl_hardware_can_INCLUDE_DIRS}
  ${icl_hardware_canopen_INCLUDE_DIRS}
  ${icl_core_INCLUDE_DIRS}
  ${icl_comm_INCLUDE_DIRS}
)


## Declare a cpp executable
add_executable(schunk_canopen_driver_node
  src/SchunkCanopenNode.cpp
  src/SchunkCanopenHardwareInterface.cpp
)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
add_dependencies(schunk_canopen_driver_node ${PROJECT_NAME}_generate_messages_cpp)

## Specify libraries to link a library or executable target against
 target_link_libraries(schunk_canopen_driver_node
   ${icl_hardware_LIBRARIES}
   ${icl_hardware_canopen_LIBRARIES}
   ${icl_core_LIBRARIES}
   ${icl_comm_INCLUDE_DIRS}
   ${catkin_LIBRARIES}
 )


## Declare a cpp executable
add_executable(schunk_canopen_driver_move_home_node
  src/MoveToHomeNode.cpp
)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
add_dependencies(schunk_canopen_driver_move_home_node ${PROJECT_NAME}_generate_messages_cpp)

## Specify libraries to link a library or executable target against
 target_link_libraries(schunk_canopen_driver_move_home_node
   ${icl_hardware_LIBRARIES}
   ${icl_hardware_canopen_LIBRARIES}
   ${icl_core_LIBRARIES}
   ${icl_comm_INCLUDE_DIRS}
   ${catkin_LIBRARIES}
 )

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
 install(TARGETS schunk_canopen_driver_node schunk_canopen_driver_move_home_node
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
 )

## Mark cpp header files for installation
 install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
#   FILES_MATCHING PATTERN "*.h"
#   PATTERN ".svn" EXCLUDE
 )


#config files
install(DIRECTORY etc/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/etc)

#config files
install(DIRECTORY config/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/config)

#Meshes
install(DIRECTORY meshes/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/meshes)

#URDF
install(DIRECTORY urdf/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/urdf)

# install the launch files
install(DIRECTORY launch/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

## Mark other files for installation (e.g. launch and bag files, etc.)
# install(FILES
#   # myfile1
#   # myfile2
#   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
# )

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_ros_canopen_schunk_chain.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)
