=== icmaker/CMakeLists.txt ===
# this is for emacs file handling -*- mode: cmake; indent-tabs-mode: nil -*-

# -- BEGIN LICENSE BLOCK ----------------------------------------------
# This file is part of the icmaker build system.
#
# This program is free software licensed under the BSD License. You can
# find a copy of this license in the LICENSE folder in the top directory
# of the source code.
#
# © Copyright 2016 FZI Forschungszentrum Informatik, Karlsruhe, Germany
# -- END LICENSE BLOCK ------------------------------------------------

# ----------------------------------------------------------------------------
#  Root CMake file for IcMaker
#
#    From the off-tree build directory, invoke:
#      $ cmake <PATH_TO_ICMAKER_ROOT>
#
#
#   - OCT-2010: Initial version <schamm@fzi.de>
#               Taken from OpenCV
#
# ----------------------------------------------------------------------------

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)
# Add these standard paths to the search paths for FIND_LIBRARY
# to find libraries from these locations first
IF(UNIX)
  SET(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /lib /usr/lib)
ENDIF()
# it _must_ go before PROJECT(IcMaker) in order to work
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    IF(WIN32)
        SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR} CACHE PATH "Install path prefix, prepended onto install directories (default: CMAKE_BINARY_DIR)." FORCE)
    ELSE()
        SET(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/export" CACHE PATH "Install path prefix, prepended onto install directories (default: ../export)." FORCE)
    ENDIF()
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

SET(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo" CACHE STRING "Configs" FORCE)
SET(CMAKE_C_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_CXX_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_MODULE_LINKER_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "" CACHE INTERNAL "" FORCE)
SET(CMAKE_VERBOSE OFF CACHE BOOL "Verbose mode")

IF(CMAKE_VERBOSE OR CMAKE_EXTRA_GENERATOR MATCHES "Eclipse CDT.*")
    SET(CMAKE_VERBOSE_MAKEFILE ON)
ENDIF()

IF(ICMAKER_PROJECT_NAME)
  SET(ICMAKER_PROJECT_NAME ${ICMAKER_PROJECT_NAME} CACHE INTERNAL "")
ELSE()
  SET(ICMAKER_PROJECT_NAME IcMaker CACHE INTERNAL "")
ENDIF()
PROJECT(${ICMAKER_PROJECT_NAME})

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

IF(MSVC)
    SET(CMAKE_USE_RELATIVE_PATHS ON CACHE INTERNAL "" FORCE)
ENDIF()

# --------------------------------------------------------------
# Indicate CMake 2.7 and above that we don't want to mix relative
#  and absolute paths in linker lib lists.
# Run "cmake --help-policy CMP0003" for more information.
# --------------------------------------------------------------
IF(POLICY CMP0003)
    CMAKE_POLICY(SET CMP0003 NEW)
ENDIF()
IF(POLICY CMP0015)
    CMAKE_POLICY(SET CMP0015 NEW)
ENDIF()

# ----------------------------------------------------------------------------
#  Current version number:
# ----------------------------------------------------------------------------
SET(ICMAKER_VERSION "1.0.0")

STRING(REGEX MATCHALL "[0-9]" ICMAKER_VERSION_PARTS "${ICMAKER_VERSION}")

LIST(GET ICMAKER_VERSION_PARTS 0 ICMAKER_VERSION_MAJOR)
LIST(GET ICMAKER_VERSION_PARTS 1 ICMAKER_VERSION_MINOR)
LIST(GET ICMAKER_VERSION_PARTS 2 ICMAKER_VERSION_PATCH)

SET(ICMAKER_SOVERSION "${ICMAKER_VERSION_MAJOR}.${ICMAKER_VERSION_MINOR}")

IF(WIN32)
    # Postfix of DLLs:
    SET(ICMAKER_DLLVERSION "${ICMAKER_VERSION_MAJOR}${ICMAKER_VERSION_MINOR}${ICMAKER_VERSION_PATCH}")
    SET(ICMAKER_DEBUG_POSTFIX d)
ELSE()
    # Postfix of so's:
    #SET(ICMAKER_DLLVERSION "${ICMAKER_VERSION_MAJOR}${ICMAKER_VERSION_MINOR}${ICMAKER_VERSION_PATCH}")
    SET(ICMAKER_DLLVERSION "")
    SET(ICMAKER_DEBUG_POSTFIX)
ENDIF()


# ----------------------------------------------------------------------------
# Build static or dynamic libs?
# ----------------------------------------------------------------------------
# Default: dynamic libraries:
SET(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")
IF(BUILD_SHARED_LIBS)
    SET(ICMAKER_BUILD_SHARED_LIB 1)
ELSE(BUILD_SHARED_LIBS)
    SET(ICMAKER_BUILD_SHARED_LIB 0)
	ADD_DEFINITIONS(-D_IC_STATIC_)

        # set /MT for windows static build according to http://www.cmake.org/Wiki/CMake_FAQ#How_can_I_build_my_MSVC_application_with_a_static_runtime.3F
        SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_RELEASE} /MTd")
        SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} /MT")

ENDIF(BUILD_SHARED_LIBS)

# ----------------------------------------------------------------------------
#  Variables for icmaker.h.cmake
# ----------------------------------------------------------------------------
SET(PACKAGE "icmaker")
SET(PACKAGE_NAME "icmaker")
SET(PACKAGE_STRING "${PACKAGE} ${ICMAKER_VERSION}")
SET(PACKAGE_TARNAME "${PACKAGE}")
SET(PACKAGE_VERSION "${ICMAKER_VERSION}")

# Configure IcMaker:
# ===================================================
SET(ICMAKER_VERBOSE OFF CACHE BOOL "Verbose IcMaker status messages")
SET(ICMAKER_USE_DEPRECATED_MACROS OFF CACHE BOOL "Allow usage of deprecated macros")
SET(ICMAKER_USE_TCMALLOC OFF CACHE BOOL "Link everything against tcmalloc from Google's perftools")

# Detect GNU version:
# ===================================================
IF(CMAKE_COMPILER_IS_GNUCXX)
    EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} --version
                    OUTPUT_VARIABLE CMAKE_ICMAKER_GCC_VERSION_FULL
                    OUTPUT_STRIP_TRAILING_WHITESPACE)

    # Typical output in CMAKE_ICMAKER_GCC_VERSION_FULL: "c+//0 (whatever) 4.2.3 (...)"
    #  Look for the version number
    STRING(REGEX MATCH "[0-9].[0-9].[0-9]" CMAKE_GCC_REGEX_VERSION "${CMAKE_ICMAKER_GCC_VERSION_FULL}")

    # Split the three parts:
    STRING(REGEX MATCHALL "[0-9]" CMAKE_ICMAKER_GCC_VERSIONS "${CMAKE_GCC_REGEX_VERSION}")

    LIST(GET CMAKE_ICMAKER_GCC_VERSIONS 0 CMAKE_ICMAKER_GCC_VERSION_MAJOR)
    LIST(GET CMAKE_ICMAKER_GCC_VERSIONS 1 CMAKE_ICMAKER_GCC_VERSION_MINOR)

    SET(CMAKE_ICMAKER_GCC_VERSION ${CMAKE_ICMAKER_GCC_VERSION_MAJOR}${CMAKE_ICMAKER_GCC_VERSION_MINOR})
    MATH(EXPR CMAKE_ICMAKER_GCC_VERSION_NUM "${CMAKE_ICMAKER_GCC_VERSION_MAJOR}*100 + ${CMAKE_ICMAKER_GCC_VERSION_MINOR}")
    MESSAGE(STATUS "Detected version of GNU GCC: ${CMAKE_ICMAKER_GCC_VERSION} (${CMAKE_ICMAKER_GCC_VERSION_NUM})")

    IF(WIN32)
        EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
                  OUTPUT_VARIABLE CMAKE_ICMAKER_GCC_TARGET_MACHINE
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
        IF(CMAKE_ICMAKER_GCC_TARGET_MACHINE MATCHES "64")
            SET(MINGW64 1)
        ENDIF()
    ENDIF()
ENDIF()

# Load additional CMake modules
# ===================================================
IF(ICMAKER_DIRECTORY)
MESSAGE(STATUS "icmaker dir is ${ICMAKER_DIRECTORY}")
    SET(CMAKE_MODULE_PATH "${ICMAKER_DIRECTORY}/CMakeModules/;${CMAKE_MODULE_PATH}")
ELSE()
    SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/;${CMAKE_MODULE_PATH}")
ENDIF()

# Build/install (or not) some apps:
# ===================================================
SET(BUILD_EXAMPLES ON CACHE BOOL "Build all examples")

# Build tests:
# ===================================================
SET(BUILD_TESTS ON CACHE BOOL "Build tests")
ENABLE_TESTING() # Always enable testing, so that at least the "test" target is available, even if the tests are not built!

IF(ICMAKER_DIRECTORY)
    INCLUDE(${ICMAKER_DIRECTORY}/IcMakerMacros.cmake REQUIRED)
ELSE()
    INCLUDE(IcMakerMacros.cmake REQUIRED)
ENDIF()

IF(UNIX)
#    IF(ICMAKER_DIRECTORY)
#        INCLUDE(${ICMAKER_DIRECTORY}/IcMakerFindPkgConfig.cmake OPTIONAL)
#    ELSE()
#        INCLUDE(IcMakerFindPkgConfig.cmake OPTIONAL)
#    ENDIF()
    INCLUDE(CheckFunctionExists)
    INCLUDE(CheckIncludeFile)
ENDIF()

# Enable or disable CUDA (disabled by default because of compiler compatibility
# ===================================================
SET(ENABLE_CUDA OFF CACHE BOOL "Enable CUDA - if off, will cause CUDA find script to not run.")

# Set compiler flags
# ===================================================
IF(CMAKE_COMPILER_IS_GNUCXX)
    SET(ENABLE_PROFILING OFF CACHE BOOL "Enable profiling in the GCC compiler (Add flags: -g -pg)")
    SET(USE_OMIT_FRAME_POINTER ON CACHE BOOL "Enable -fomit-frame-pointer for GCC")
    SET(USE_PERMISSIVE OFF CACHE BOOL "Enable -fpermissive for GCC")
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES arm*)
        # We can use only -O2 because the -O3 causes gcc crash
        SET(USE_O2 ON CACHE BOOL "Enable -O2 for GCC")
    ENDIF()

    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES amd64*)
        SET(X86_64 1)
    ENDIF()
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES x86_64*)
        SET(X86_64 1)
    ENDIF()

    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES i686*)
        SET(X86 1)
    ENDIF()
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES i386*)
        SET(X86 1)
    ENDIF()
    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES x86*)
        SET(X86 1)
    ENDIF()

    IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES powerpc*)
        SET(ENABLE_POWERPC ON CACHE BOOL "Enable PowerPC for GCC")
    endif ()

    IF(X86 OR X86_64)
        # enable everything, since the available set of instructions is checked at runtime
        SET(ENABLE_SSE ON CACHE BOOL "Enable SSE for GCC")
        SET(ENABLE_SSE2 ON CACHE BOOL "Enable SSE2 for GCC")
        SET(ENABLE_SSE3 OFF CACHE BOOL "Enable SSE3 for GCC")
        SET(ENABLE_SSSE3 OFF CACHE BOOL "Enable SSSE3 for GCC")
        #SET(ENABLE_SSE4_1 OFF CACHE BOOL "Enable SSE4.1 for GCC")
    ENDIF()
ENDIF()

# ----------------------------------------------------------------------------
# IcMaker Definitions
# ----------------------------------------------------------------------------

SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

# IcMaker operating system defines
# ===================================================
IF(WIN32)
    ADD_DEFINITIONS(-D_SYSTEM_WIN32_ -D_USE_MATH_DEFINES)
ENDIF(WIN32)

IF(UNIX)
  IF(NOT APPLE)
    ADD_DEFINITIONS(-D_SYSTEM_LINUX_ -D_SYSTEM_POSIX_)
  ELSE()
    ADD_DEFINITIONS(-D_SYSTEM_DARWIN_ -D_SYSTEM_POSIX_)
  ENDIF(NOT APPLE)
ENDIF(UNIX)

ADD_DEFINITIONS(-D_SYSTEM_IDENTIFIER_=${CMAKE_SYSTEM_PROCESSOR}.${CMAKE_SYSTEM_NAME})

# ----------------------------------------------------------------------------
#           Set the maximum level of warnings:
# ----------------------------------------------------------------------------
# May be set to true for development
SET(ICMAKER_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Treat warnings as errors")

SET(EXTRA_C_FLAGS "")
SET(EXTRA_C_FLAGS_RELEASE "")
SET(EXTRA_C_FLAGS_RELWITHDEBINFO "")
SET(EXTRA_C_FLAGS_DEBUG "")
SET(EXTRA_EXE_LINKER_FLAGS "")
SET(EXTRA_EXE_LINKER_FLAGS_RELEASE "")
SET(EXTRA_EXE_LINKER_FLAGS_RELWITHDEBINFO "")
SET(EXTRA_EXE_LINKER_FLAGS_DEBUG "")

IF(MSVC)
    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /D _CRT_SECURE_NO_DEPRECATE	/D _CRT_NONSTDC_NO_DEPRECATE /D _SCL_SECURE_NO_WARNINGS /D WIN32_LEAN_AND_MEAN /D _WIN32_WINNT=0x0501 /D NOMINMAX")
    # 64-bit portability warnings, in MSVC8
    IF(MSVC80)
        SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /Wp64")
    ENDIF()
    #IF(MSVC90)
    #    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /D _BIND_TO_CURRENT_CRT_VERSION=1 /D _BIND_TO_CURRENT_VCLIBS_VERSION=1")
    #ENDIF()

    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /nologo")
	SET(EXTRA_EXE_LINKER_FLAGS "${EXTRA_EXE_LINKER_FLAGS} /nologo")
	SET(EXTRA_EXE_LINKER_FLAGS_DEBUG "${EXTRA_EXE_LINKER_FLAGS_DEBUG} /DEBUG")

    # Remove unreferenced functions: function level linking
#    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} /Gy")
#    SET(EXTRA_C_FLAGS_RELEASE "${EXTRA_C_FLAGS_RELEASE} /Zi")
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX)
    # High level of warnings.
    SET(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wall")

    IF(USE_CXX11)
