=== debian/control ===
Source: ros-indigo-schunk-canopen-driver
Section: misc
Priority: extra
Maintainer: Georg Heppner <heppner@fzi.de>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-actionlib, ros-indigo-catkin, ros-indigo-control-msgs, ros-indigo-controller-manager, ros-indigo-fzi-icl-can, ros-indigo-fzi-icl-core, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-message-generation, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-urdf
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-schunk-canopen-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-actionlib, ros-indigo-control-msgs, ros-indigo-controller-manager, ros-indigo-fzi-icl-can, ros-indigo-fzi-icl-core, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-message-runtime, ros-indigo-robot-state-publisher, ros-indigo-ros-controllers, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-urdf, ros-indigo-xacro
Description: The schunk_canopen_driver package
